<template>
  <q-form ref="formRef" @submit="handleNextFormSectionRequested">

    <h5 class="q-my-sm schedule-header">{{ $t("schedule_session.section_1.title") }}</h5>
    <q-input :label="$t('required.name_of_session')" filled v-model="name"
      :rules="[(val) => (val && val.length > 0) || $t('empty.name_of_session')]" />
    <div style="height: 1rem" />

    <label class="q-my-md text-subtitle1">
      {{ $t("schedule_session.section_1.privacy_label") }}
    </label>
    <q-option-group :options="privacyOptions" type="radio" v-model="privacySelection" />

    <q-page-sticky position="bottom-right">
      <q-btn type="submit" fab color="primary" class="q-ma-sm">
        <div class="q-pl-sm">
          {{ $t("schedule_session.next") }}
        </div>
        <q-icon name="chevron_right" />
      </q-btn>
    </q-page-sticky>
  </q-form>
</template>
<script>

export default {
  props: {
    requestSaveFormSection: {
      required: true,
      // (name: string, privacyOption: string) => void
    },
    initialName: {
      required: true,
    },
    initialPrivacySelection: {
      required: true,
    }
  },
  data()
  {
    return {
      name: `${this.initialName || ""}`, // Copy the initial name
      privacySelection: `${this.initialPrivacySelection || "open"}`, // copy the initial privacy selection
      proposedStartTime: null,
    };
  },
  methods: {
    handleNextFormSectionRequested()
    {
      this.$refs.formRef.validate().then((success) =>
      {
        if (success)
        {
          this.requestSaveFormSection(
            this.name,
            this.privacySelection
          );
        }
      });
    },
  },
  computed: {
    privacyOptions()
    {
      return [
        {
          label: this.$t("privacy.open"),
          value: "open",
        },
        {
          label: this.$t("privacy.private"),
          value: "private",
        },
        {
          label: this.$t("privacy.closed"),
          value: "closed",
        },
      ]
    }
  },
};
</script>

<style scoped>
.datepicker {
  width: 250px;
}

.booking-text {
  padding: 10px;
  text-align: center;
}

.booking-btn {
  height: 40px;
  font-size: medium;
  margin: 5px;
}

.available {
  text-align: center;
  color: forestgreen;
}

.unavailable {
  text-align: center;
  color: darkred;
}

.booking-picker {
  max-width: 80px;
  display: inline-block;
  font-size: medium;
  padding: 2px;
  margin: 5px;
}

.booking-explainer {
  text-align: center;
  margin: 10px;
}
</style>